%{!?_pkgdocdir: %global _pkgdocdir %{_datadir}/doc/%{name}-%{version}}

%global with_nginx     1
%global with_httpd     1

%global upstream_version 5.2.1

Name: phpMyAdmin
Version: %{upstream_version}%{?upstream_prever:~%{upstream_prever}}
Release:    1%{?dist}
Summary: A web interface for MySQL and MariaDB

License: GPL-2.0-or-later AND MIT AND BSD 2-Clause AND BSD 3-Clause AND LGPL-3.0-or-later AND MPL-2.0 AND ISC
URL: https://www.phpmyadmin.net/
Source0: https://files.phpmyadmin.net/%{name}/%{upstream_version}%{?upstream_prever:-%upstream_prever}/%{name}-%{upstream_version}%{?upstream_prever:-%upstream_prever}-all-languages.tar.xz
Source1: https://files.phpmyadmin.net/%{name}/%{upstream_version}%{?upstream_prever:-%upstream_prever}/%{name}-%{upstream_version}%{?upstream_prever:-%upstream_prever}-all-languages.tar.xz.asc
Source2: phpMyAdmin.htaccess
Source3: phpMyAdmin.nginx
Source4: https://files.phpmyadmin.net/phpmyadmin.keyring
Source5: phpMyAdmin-bundled.php

Patch0:  phpMyAdmin-certs.patch

BuildArch: noarch
BuildRequires: gnupg2
BuildRequires: php(language) >= 7.2.5
BuildRequires: php-cli
BuildRequires: php-json

Requires(post): coreutils sed
Requires:  webserver
%if %{with_nginx}
Requires:   nginx-filesystem
%endif
%if %{with_httpd}
Requires:  httpd-filesystem
Requires:  php(httpd)
Suggests:  httpd
%endif
Requires:  php(language) >= 7.2.5
Requires:  php-hash
Requires:  php-iconv
Requires:  php-json
Requires:  php-mysqli
Requires:  php-openssl
Requires:  php-pcre
Requires:  php-xml

Provides:  bundled(php-bacon-bacon-qr-code) = 2.0.8
Provides:  bundled(php-beberlei-assert) = v3.3.2
Provides:  bundled(php-code-lts-u2f-php-server) = v1.2.1
Provides:  bundled(php-dasprid-enum) = 1.0.3
Provides:  bundled(php-google-recaptcha) = 1.2.4
Provides:  bundled(php-nikic-fast-route) = v1.3.0
Provides:  bundled(php-twig-twig) = v3.5.0
Provides:  bundled(php-phpmyadmin-motranslator) = 5.3.0
Provides:  bundled(php-phpmyadmin-shapefile) = 3.0.1
Provides:  bundled(php-phpmyadmin-sql-parser) = 5.7.0
Provides:  bundled(php-paragonie-sodium-compat) = v1.19.0
Provides:  bundled(php-tecnickcom-tcpdf) = 6.6.2
Provides:  bundled(php-brick-math) = 0.8.17
Provides:  bundled(php-composer-ca-bundle) = 1.3.5
Provides:  bundled(php-fgrosse-phpasn1) = v2.5.0
Provides:  bundled(php-fig-http-message-util) = 1.1.5
Provides:  bundled(php-league-uri) = 6.4.0
Provides:  bundled(php-league-uri-interfaces) = 2.3.0
Provides:  bundled(php-paragonie-constant-time-encoding) = v2.6.3
Provides:  bundled(php-paragonie-random-compat) = v9.99.100
Provides:  bundled(php-phpmyadmin-twig-i18n-extension) = v4.0.1
Provides:  bundled(php-pragmarx-google2fa) = v8.0.1
Provides:  bundled(php-pragmarx-google2fa-qrcode) = v2.1.1
Provides:  bundled(php-psr-cache) = 1.0.1
Provides:  bundled(php-psr-container) = 1.1.1
Provides:  bundled(php-psr-http-client) = 1.0.1
Provides:  bundled(php-psr-http-factory) = 1.0.1
Provides:  bundled(php-psr-http-message) = 1.0.1
Provides:  bundled(php-psr-log) = 1.1.4
Provides:  bundled(php-ralouphie-getallheaders) = 3.0.3
Provides:  bundled(php-ramsey-collection) = 1.1.4
Provides:  bundled(php-ramsey-uuid) = 4.2.3
Provides:  bundled(php-slim-psr7) = 1.4
Provides:  bundled(php-spomky-labs-base64url) = v2.0.4
Provides:  bundled(php-spomky-labs-cbor-php) = v1.1.1
Provides:  bundled(php-symfony-cache) = v5.4.19
Provides:  bundled(php-symfony-cache-contracts) = v2.5.2
Provides:  bundled(php-symfony-config) = v5.4.19
Provides:  bundled(php-symfony-dependency-injection) = v5.4.20
Provides:  bundled(php-symfony-deprecation-contracts) = v2.5.2
Provides:  bundled(php-symfony-expression-language) = v5.4.19
Provides:  bundled(php-symfony-filesystem) = v5.4.19
Provides:  bundled(php-symfony-polyfill-ctype) = v1.27.0
Provides:  bundled(php-symfony-polyfill-mbstring) = v1.27.0
Provides:  bundled(php-symfony-polyfill-php73) = v1.27.0
Provides:  bundled(php-symfony-polyfill-php80) = v1.27.0
Provides:  bundled(php-symfony-polyfill-php81) = v1.27.0
Provides:  bundled(php-symfony-process) = v5.4.19
Provides:  bundled(php-symfony-service-contracts) = v2.5.2
Provides:  bundled(php-symfony-var-exporter) = v5.4.19
Provides:  bundled(php-thecodingmachine-safe) = v1.3.3
Provides:  bundled(php-web-auth-cose-lib) = v3.3.12
Provides:  bundled(php-web-auth-metadata-service) = v3.3.12
Provides:  bundled(php-web-auth-webauthn-lib) = v3.3.12
Provides:  bundled(php-webmozart-assert) = 1.11.0
Provides:  bundled(php-williamdes-mariadb-mysql-kbs) = v1.2.14

Requires:  php-dom
Requires:  php-intl
Requires:  php-posix
Requires:  php-ctype
Requires:  php-curl
Requires:  php-zlib
Requires:  php-bz2
Requires:  php-zip
Requires:  php-gd
Requires:  php-mbstring
Requires:  php-date
Requires:  php-filter
Requires:  php-libxml
Requires:  php-session
Requires:  php-simplexml
Requires:  php-spl
Requires:  php-xmlwriter
Requires:  ca-certificates

Provides:  bundled(js-codemirror)
Provides:  bundled(js-jqplot) = 1.0.9
Provides:  bundled(js-jquery) = 3.2.1
Provides:  bundled(js-openlayers)
Provides:  bundled(js-tracekit)

Provides:  php-composer(phpmyadmin/phpmyadmin) = %{version}
Provides:  phpmyadmin   =  %{version}-%{release}


%description
phpMyAdmin is a tool written in PHP intended to handle the administration of
MySQL over the Web. Currently it can create and drop databases,
create/drop/alter tables, delete/edit/add fields, execute any SQL statement,
manage keys on fields, manage privileges,export data into various formats and
is available in 50 languages


%prep
%{?gpgverify:%{gpgverify} --keyring='%{SOURCE4}' --signature='%{SOURCE1}' --data='%{SOURCE0}'}

%setup -qn phpMyAdmin-%{upstream_version}%{?upstream_prever:-%upstream_prever}-all-languages
%patch0 -p1
rm -r vendor/composer/ca-bundle/res/

sed -e "/'blowfish_secret'/s@''@'MUSTBECHANGEDONINSTALL'@"  \
    -e "/'UploadDir'/s@''@'%{_localstatedir}/lib/%{name}/upload'@"  \
    -e "/'SaveDir'/s@''@'%{_localstatedir}/lib/%{name}/save'@" \
    config.sample.inc.php >CONFIG

sed -e "/'changeLogFile'/s@ROOT_PATH@'%{_pkgdocdir}/'@" \
    -e "/'licenseFile'/s@ROOT_PATH@'%{_pkgdocdir}/'@" \
    -e "/'configFile'/s@ROOT_PATH@'%{_sysconfdir}/%{name}/'@" \
%if 0%{?_licensedir:1}
    -e '/licenseFile/s:%_defaultdocdir:%_defaultlicensedir:' \
%endif
    -e "/versionSuffix/s/''/'-%{release}'/" \
    -e "/tempDir/s@ROOT.*tmp'@'%{_localstatedir}/lib/%{name}/temp'@" \
    -e "/cacheDir/s@ROOT.*cache'@'%{_localstatedir}/lib/%{name}/cache'@" \
    -i libraries/vendor_config.php

grep '=>' libraries/vendor_config.php

php %{SOURCE5} vendor/composer/installed.json


%build


%install
mkdir -p %{buildroot}/%{_datadir}/%{name}
cp -ad ./* %{buildroot}/%{_datadir}/%{name}
install -Dpm 0640 CONFIG %{buildroot}/%{_sysconfdir}/%{name}/config.inc.php
install -Dpm 0644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/httpd/conf.d/phpMyAdmin.conf
%if %{with_nginx}
install -Dpm 0644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/nginx/default.d/phpMyAdmin.conf
%endif

mkdir -p %{buildroot}/%{_localstatedir}/lib/%{name}/{upload,save,config,temp}

rm -f %{buildroot}/%{_datadir}/%{name}/config.sample.inc.php
rm -f %{buildroot}/%{_datadir}/%{name}/*txt
rm -f %{buildroot}/%{_datadir}/%{name}/[CDLR]*
rm -f %{buildroot}/%{_datadir}/%{name}/libraries/.htaccess
rm -f %{buildroot}/%{_datadir}/%{name}/setup/lib/.htaccess
rm -f %{buildroot}/%{_datadir}/%{name}/setup/frames/.htaccess
rm -rf %{buildroot}%{_datadir}/%{name}/contrib
rm     %{buildroot}%{_datadir}/%{name}/composer.*
rm -rf %{buildroot}%{_datadir}/%{name}/tmp/
mv     %{buildroot}%{_datadir}/%{name}/libraries/cache %{buildroot}/%{_localstatedir}/lib/%{name}/cache


rm -rf    %{buildroot}%{_datadir}/%{name}/examples/
rm -rf    %{buildroot}%{_datadir}/%{name}/doc/
mkdir -p  %{buildroot}%{_datadir}/%{name}/doc/
ln -s %{_pkgdocdir}/html  %{buildroot}%{_datadir}/%{name}/doc/html

mv -f %{buildroot}%{_datadir}/%{name}/js/vendor/jquery/MIT-LICENSE.txt LICENSE-jquery
mv -f %{buildroot}%{_datadir}/%{name}/js/vendor/codemirror/LICENSE LICENSE-codemirror


%pretrans
if  [ -d %{_datadir}/%{name}/doc/html ]; then
  rm -rf %{_datadir}/%{name}/doc/html
fi

%post
SECRET=$(printf "%04x%04x%04x%04x%04x%04x%04x%04x" $RANDOM $RANDOM $RANDOM $RANDOM $RANDOM $RANDOM $RANDOM $RANDOM)
sed -e "/'blowfish_secret'/s/MUSTBECHANGEDONINSTALL/$SECRET/" \
    -i %{_sysconfdir}/%{name}/config.inc.php


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE*
%doc ChangeLog README CONTRIBUTING.md config.sample.inc.php
%doc doc/html/
%doc examples/
%doc composer.json
%{_datadir}/%{name}
%attr(0750,root,apache) %dir %{_sysconfdir}/%{name}
%config(noreplace) %attr(0640,root,apache) %{_sysconfdir}/%{name}/config.inc.php
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%if %{with_nginx}
%config(noreplace) %{_sysconfdir}/nginx/default.d/%{name}.conf
%endif
%dir %{_localstatedir}/lib/%{name}/
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/upload
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/save
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/config
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/temp
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/cache
     %attr(0640,apache,apache) %{_localstatedir}/lib/%{name}/cache/*


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.2.1-1
- initial build
